

'program GCA186
'railroad crossing controller for two TRACKS both in one direction
Define CONF_WORD = 0x3f50

CMCON = 7
TRISA = 255
TRISB = 0
PORTB = 0
AllDigital

Symbol hall_a = RA6
Symbol hall_b = RA7
Symbol hall_c = RA0
Symbol hall_d = RA1
Symbol servo_1 = RB5
Symbol servo_2 = RB4
Dim servo_value As Word
Dim old_servo_1 As Bit
Dim old_servo_2 As Bit
Symbol flash_1 = RB3
Symbol flash_2 = RB2
Dim flashtime As Byte
Dim rel_off_delay As Byte
Symbol rel = RB1
Dim old_hall_a As Bit
Dim old_hall_b As Bit
Dim old_hall_c As Bit
Dim old_hall_d As Bit
Dim count_enter_a As Byte
Dim count_enter_d As Byte
Dim count_down_a_to_d As Byte
Dim count_down_d_to_a As Byte
Dim program As Byte
Dim track_a_to_b_occ As Bit
Dim track_d_to_c_occ As Bit
old_hall_a = 0
old_hall_b = 0
old_hall_c = 0
old_hall_d = 0
old_servo_1 = 0
old_servo_2 = 0
count_down_a_to_d = 0
count_down_d_to_a = 0
count_enter_a = 0
count_enter_d = 0
track_a_to_b_occ = 0
track_d_to_c_occ = 0
'program option":
'program = 0  idle task
'_         1  entered a 'start activation of barriers and counting a
'_         2  BARRIERS ARE DOWN, wait loop before shutt off sound
'_         3  activated a or d 'start counting down
'_         4  counted to zero, start freeing barriers,

servo_value = 800  'start in barrier up position
For flashtime = 1 To 20
	Gosub flashing
	WaitMs 100
Next flashtime
program = 0
main:
	If hall_a = 0 Then
		If old_hall_a = 0 Then
			old_hall_a = 1  'only one time reaction on hall_a
			If count_enter_a = 0 Then  'no matter what program, start again
				program = 1
			Endif
			count_enter_a = count_enter_a + 1
			track_a_to_b_occ = 1
		Endif
	Else
		old_hall_a = 0
	Endif
	If hall_d = 0 Then
		If old_hall_d = 0 Then
			old_hall_d = 1  'only one time reaction on hall_d
			If count_enter_d = 0 Then  'no matter what program, start again
				program = 1
			Endif
			count_enter_d = count_enter_d + 1
			track_d_to_c_occ = 1
		Endif
	Else
		old_hall_d = 0
	Endif
	If hall_b = 0 Then
		If old_hall_b = 0 Then
			old_hall_b = 1  'only one time reaction on hall_c
			If count_enter_a > 0 Then
				count_enter_a = count_enter_a - 1
			Else
				track_a_to_b_occ = 0
			Endif
		Endif
	Else
		old_hall_b = 0
	Endif
	If hall_c = 0 Then
		If old_hall_c = 0 Then
			old_hall_c = 1  'only one time reaction on hall_b
			If count_enter_d > 0 Then
				count_enter_d = count_enter_d - 1
			Else
				track_d_to_c_occ = 0
			Endif
		Endif
	Else
		old_hall_c = 0
	Endif
	Select Case program
	Case 0
		flash_1 = 1
		flash_2 = 0
	Case 1  'starting barriers close
		rel = 0  'ACTIVATE SOUND
		rel_off_delay = 80
		If servo_value < 2196 Then
			servo_value = servo_value + 3
			servo_1 = 1
			WaitUs servo_value
			servo_1 = 0
			servo_2 = 1
			WaitUs servo_value
			servo_2 = 0
			WaitMs 15
		Else
			program = 2
			WaitMs 20
		Endif
	Case 2  'waiting for sound to switch off
		If rel_off_delay > 0 Then
			rel_off_delay = rel_off_delay - 1
		Else
			rel = 1  'sound off
			program = program + 1
		Endif
		WaitMs 20
	Case 3  'now waiting For the Count doen
		If track_d_to_c_occ = 0 Then
			If track_a_to_b_occ = 0 Then
				program = 4
			Endif
		Endif
	Case 4
		If servo_value > 804 Then
			servo_value = servo_value - 3
			servo_1 = 1
			WaitUs servo_value
			servo_1 = 0
			servo_2 = 1
			WaitUs servo_value
			servo_2 = 0
			WaitMs 15
		Else
			WaitMs 20
			program = 0
		Endif
	Case Else
		WaitMs 20
	EndSelect
	Gosub flashing
Goto main
End                                               

flashing:
	Select Case program
	Case 0
		flash_1 = 1
		flash_2 = 0
	Case Else
		If flashtime < 24 Then
			flashtime = flashtime + 1
		Else
			flashtime = 0
			flash_1 = flash_2
			flash_2 = Not flash_1
		Endif
	EndSelect
Return                                            
